<?php
namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Notification;
use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Teknisa\MAN\Services;

class ParamsOnlinePayment extends  \Teknisa\MAN\Controllers\TeknisaCrud{

    protected $dataSourceParamsVendaOn  = 'vnd10003_ParamsVendaOnline';
    protected $dataSourceFiliaisSitef   = 'vnd10003_FiliaisParamSitef';
    protected $dataSourceFiliaisBandTef = 'vnd10003_FiliaisBandEsitef';
    protected $dataSourceBandeSitef     = 'vnd10003_BandeSitef';
	protected $parameterBagColumns      = array('NRORG');

    protected $BandeSitefService;

	public function __construct ($crudService, $parameterBag, $entityManager, Services\BandeSitef $BandeSitefService) {
		$this->crudService 				= $crudService;
		$this->parameterBag 			= $parameterBag;
        $this->entityManager            = $entityManager;
		$this->BandeSitefService 		= $BandeSitefService;
	}

    public function findParamVendaOnline(DTO\Request\Filter $request, DTO\Response $response){
        $this->dataSourceName = 'vnd10003_ParamsVendaOnline';
        parent::find($request,$response);
    }

    public function saveParamVendaOnline(DTO\Request $request, DTO\Response $response){
        $this->dataSourceName = 'vnd10003_ParamsVendaOnline';
        parent::save($request,$response);
    }

    public function findFiliaisParamSitef(DTO\Request\Filter $request, DTO\Response $response){
        $this->dataSourceName = 'vnd10003_FiliaisParamSitef';
        parent::find($request,$response);
    }

    public function saveFiliaisParamSitef(DTO\Request $request, DTO\Response $response){
        $this->dataSourceName = 'vnd10003_FiliaisParamSitef';
        parent::save($request,$response);
    }

    public function findFiliaisBandEsitef(DTO\Request\Filter $request, DTO\Response $response){
        $this->dataSourceName = 'vnd10003_FiliaisBandEsitef';
        parent::find($request,$response);
    }

    public function saveFiliaisBandEsitef(DTO\Request $request, DTO\Response $response){
        $this->dataSourceName = 'vnd10003_FiliaisBandEsitef';
        $row = $request->getDataSet()->getRows();
        $row[0]['NRSEQBANDEIRA'] = $this->BandeSitefService->getNrseqbandeiraFil($row[0]['NRORG'], $row[0]['CDFILIAL']);
        parent::save($request,$response);
    }

    public function findBandeSitef(DTO\Request\Filter $request, DTO\Response $response){
        $this->dataSourceName = 'vnd10003_BandeSitef';
        parent::find($request,$response);
    }

    public function saveBandeSitef(DTO\Request $request, DTO\Response $response){
        $this->dataSourceName = 'vnd10003_BandeSitef';
        $row = $request->getDataSet()->getRows();
        if ($row[0]['__is_new'])
            $row[0]['NRSEQBANDEIRA'] = $this->BandeSitefService->getNrseqbandeira($row[0]['NRORG']);
        parent::save($request,$response);
    }

    public function deleteFiliaisParamSitef(DTO\Request $request, DTO\Response $response){
        $this->dataSourceName = 'vnd10003_FiliaisParamSitef';
        parent::delete($request,$response);
    }


    public function deleteFiliaisBandEsitef(DTO\Request $request, DTO\Response $response){
        $this->dataSourceName = 'vnd10003_FiliaisBandEsitef';
        parent::delete($request,$response);
    }


    public function deleteBandeSitef(DTO\Request $request, DTO\Response $response){
        $this->dataSourceName = 'vnd10003_BandeSitef';
        parent::delete($request,$response);
    }
}