<?php 
namespace Teknisa\MAN\Services;

use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use Zeedhi\Framework\DB\StoredProcedure\Param;
use Doctrine\ORM\EntityManager;
use Teknisa\MAN\Utilities;

class RelVendasRealizadasMediaPessoaService {
    	
	protected $entityManager;

	public function __construct(\Doctrine\ORM\EntityManager $entityManager)  {
		$this->entityManager = $entityManager;
	}
	
	public function vendasRealizadas($P_CDFILIAL, $P_CDCAIXA, $P_TCDCAIXA, $P_CDVENDEDOR, $P_TCDVENDEDOR, $P_DTVENDAINI, $P_DTVENDAFIN){
		$params = array(
			':P_CDFILIAL' => $P_CDFILIAL,
			':P_CDCAIXA'  => $P_CDCAIXA,
			':P_TCDCAIXA'    => $P_TCDCAIXA,
			':P_CDVENDEDOR'  => $P_CDVENDEDOR,
			':P_TCDVENDEDOR' => $P_TCDVENDEDOR,
			':P_DTVENDAINI'  => $P_DTVENDAINI,
			':P_DTVENDAFIN'  => $P_DTVENDAFIN
			);
		return $this->entityManager->getConnection()->fetchAll(self::REL_VENDAS_REALIZADAS_MEDIA_PESSOA, $params);
	}
	
	
    const REL_VENDAS_REALIZADAS_MEDIA_PESSOA =
    "SELECT V.NRCOMANDAVND, V.CDFILIAL, F.NMFILIAL, V.CDLOJA, L.NMLOJA, V.CDCAIXA, C.NMCAIXA, NVL(V.NRPESMESAVENDA, 1) AS NRPESMESAVENDA,
       V.DTENTRVENDA, TO_CHAR(V.DTENTRVENDA, 'DD/MM/YYYY') AS DTNTRVENDA, V.CDVENDEDOR, VE.NMRAZSOCVEN, NVL(V.NRCUPOMFIS, V.NRNOTAFISCALCE) AS CUPOM_NOTA, V.NRMESA,
       SUM(TRUNC(IT.QTPRODVEND * (IT.VRUNITVEND+NVL(IT.VRUNITVENDCL,0)),2) - NVL(IT.VRDESITVEND,0) + 
    NVL(IT.VRACRITVEND, 0)) AS VRTOTVEND, (SUM(TRUNC(IT.QTPRODVEND * (IT.VRUNITVEND+NVL(IT.VRUNITVENDCL,0)),2) - NVL(IT.VRDESITVEND,0) + 
    NVL(IT.VRACRITVEND, 0))/NVL(V.NRPESMESAVENDA, 1)) AS VRTOTPORPESSOA, DTVENDA, V.CDFILIAL || ' - '  || F.NMFILIAL AS LABELFILIAL
      FROM VENDA V, ITEMVENDA IT, FILIAL F, LOJA L, CAIXA C, VENDEDOR VE
     WHERE (INSTR(:P_CDFILIAL, V.CDFILIAL) <> 0) 
       AND IT.CDFILIAL = V.CDFILIAL
       AND ((INSTR(:P_CDCAIXA, V.CDFILIAL||V.CDCAIXA) <> 0) OR (:P_TCDCAIXA = 'T'))
       AND IT.CDCAIXA = V.CDCAIXA
       AND IT.NRSEQVENDA = V.NRSEQVENDA
       AND F.CDFILIAL = V.CDFILIAL
       AND L.CDFILIAL = V.CDFILIAL
       AND L.CDLOJA = V.CDLOJA
       AND C.CDFILIAL = V.CDFILIAL
       AND C.CDCAIXA = V.CDCAIXA
       AND ((INSTR(:P_CDVENDEDOR, V.CDVENDEDOR) <> 0)OR(:P_TCDVENDEDOR = 'T')) 
       AND (V.CDVENDEDOR = VE.CDVENDEDOR(+)) 
       AND (TRUNC(V.DTENTRVENDA) BETWEEN TO_DATE(:P_DTVENDAINI, 'DD/MM/YYYY')  AND TO_DATE(:P_DTVENDAFIN, 'DD/MM/YYYY'))
       AND (V.IDSITUVENDA = 'O')
    GROUP BY V.NRCOMANDAVND, V.CDFILIAL, F.NMFILIAL, V.CDLOJA, L.NMLOJA, V.CDCAIXA, C.NMCAIXA,
             V.DTENTRVENDA, V.CDVENDEDOR, VE.NMRAZSOCVEN, NVL(V.NRCUPOMFIS, V.NRNOTAFISCALCE),
             V.NRMESA, V.IDSITUVENDA, NVL(V.NRPESMESAVENDA, 1), V.DTVENDA
    ORDER BY V.CDFILIAL, V.DTENTRVENDA, V.CDVENDEDOR, NVL(V.NRCUPOMFIS, V.NRNOTAFISCALCE)
    ";
         
}